%define upstream_name    Coro
%define upstream_version 6.49

%global __requires_exclude perl\\(Exporter::\\)|perl\\(Coro::Socket::\\)
# Filter underspecified dependencies
%global __requires_exclude %{?__requires_exclude:__requires_exclude|}^perl\\(AnyEvent\\)$
%global __requires_exclude %__requires_exclude|^perl\\(AnyEvent\\) >= 4.800001$
%global __requires_exclude %__requires_exclude|^perl\\(Guard\\)$
%global __requires_exclude %__requires_exclude|^perl\\(Storable\\)$
%global __provides_exclude %{?__provides_exclude:__provides_exclude|}^perl\\(Coro\\)$

#define _without_check 1

%{?perl_default_filter}

Name:       perl-%{upstream_name}
Version:    %perl_convert_version %upstream_version
Release:    %mkrel 4

Summary:    Coroutine process abstraction
License:    GPL+ or Artistic
Group:      Development/Perl
Url:        http://search.cpan.org/dist/%{upstream_name}
Source0:    http://search.cpan.org/CPAN/authors/id/M/ML/MLEHMANN/%{upstream_name}-%{upstream_version}.tar.gz
Patch0:         %{name}-5.25-ucontext-default.patch

BuildRequires: perl(AnyEvent) >= 5.0.0
BuildRequires: perl(Canary::Stability)
BuildRequires: perl(ExtUtils::MakeMaker)
BuildRequires: perl(Guard) >= 0.500.0
BuildRequires: perl(Scalar::Util)
BuildRequires: perl(Storable) >= 2.150.0
BuildRequires: perl(common::sense)
BuildRequires: perl-devel
BuildRequires: perl-AnyEvent
BuildRequires: perl-EV >= 2.0
BuildRequires: perl-Event
BuildRequires: perl-Guard
BuildRequires: perl-IO-AIO
Obsoletes:  perl-Coro-EV       <= 6.330.0
Obsoletes:  perl-Coro-AnyEvent <= 6.330.0
Obsoletes:  perl-Coro-BDB      <= 6.330.0

%description
This module collection manages continuations in general, most often in the
form of cooperative threads (also called coros, or simply "coro" in the
documentation). They are similar to kernel threads but don't (in general) run
in parallel at the same time even on SMP machines. The specific flavor of
thread offered by this module also guarantees you that it will not switch
between threads unless necessary, at easily-identified points in your
program, so locking and parallel access are rarely an issue, making thread
programming much safer and easier than using other thread models.


%prep
%setup -q -n %{upstream_name}-%{upstream_version} 
%ifnarch %{ix86} x86_64 %{arm}
# use ucontext backend on non-x86 (setjmp didn't work on s390(x))
%patch0 -p1 -b .ucontext-default
%endif
# change shebang lines if needed
perl -pi -e 's{/opt/bin/perl}{/usr/bin/perl}' eg/* Coro/*
# remove failing test - http://rt.cpan.org/Ticket/Display.html?id=32475
rm EV/t/01_unblock.t

%build
# Disable FORTIFY_SOURCE on ARM as it breaks setjmp - RHBZ 750805
%ifarch %{arm}
RPM_OPT_FLAGS="${RPM_OPT_FLAGS} -Wp,-U_FORTIFY_SOURCE -Wp,-D_FORTIFY_SOURCE=0"
%endif

# Interractive configuration. Use default values.
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="$RPM_OPT_FLAGS" </dev/null
make

%install
%make_install


%files
%doc Changes EV INSTALL META.json META.yml MYMETA.yml README eg COPYING
%{perl_vendorarch}/*
%_mandir/man3/*


%changelog
* Tue Jul 11 2017 bb2 <bb2> - 6.490.0-4pclos2017
- rebuild against updates

